%{
%}

%token ASSIGN PRINT COMMA SEMI PLUS MINUS TIMES DIV IF THEN ELSE EOF LPAREN RPAREN
%token <int> INT
%token <string> ID

%right SEMI
%nonassoc ASSIGN
%right COMMA
%nonassoc IF THEN ELSE
%left PLUS MINUS
%left TIMES DIV

%start program
%type <Pgm.stm> program
%type <Pgm.stm> stm
%type <Pgm.stm list> stmseq
%type <Pgm.exp> exp
%type <Pgm.exp list> expseq

%%
program: stm EOF	{$1}
	;

stm: ID ASSIGN exp	{ Pgm.Assign($1,$3) }
	| PRINT expseq	{ Pgm.Print $2 }
	| LPAREN stmseq RPAREN	{ Pgm.Seq $2 }
	;

stmseq:
	stm { $1::[] }
	| stm SEMI stmseq { $1::$3 }
	;

exp:
	ID				{ Pgm.Var $1 }
	| INT			{ Pgm.Const $1 }
	| exp PLUS exp	{ Pgm.Binop($1, Pgm.Plus, $3) }
	| exp MINUS exp	{ Pgm.Binop($1, Pgm.Minus, $3) }
	| exp TIMES exp	{ Pgm.Binop($1, Pgm.Times, $3) }
	| exp DIV exp	{ Pgm.Binop($1, Pgm.Div, $3) }
	| IF exp THEN exp ELSE exp { Pgm.If($2, $4, $6) }
	| LPAREN exp RPAREN { $2 }
	;

expseq:
	exp				{ $1::[] }
	| exp COMMA expseq	{ $1::$3 }

%%
