type stm =
	Assign of id * exp
	| Print of exp list
	| Seq of stm list

and exp =
	Var of id
	| Const of int
	| Binop of exp * binop * exp
	| If of exp * exp * exp

and id = string
and binop = Plus | Minus | Times | Div

exception Not_implemented

type store = (id * int) list

let empty_store = []

let rec intp (s, m) = raise Not_implemented

let string_of_list string_of_element token l =
	let rec string_of_list' l = match l with
		[] -> ""
		| h::[] -> string_of_element h
		| h::t -> string_of_element h^token^string_of_list' t
	in
	("["^string_of_list' l^"]")

let rec pprint_stm s =
	let rec string_of_binop op = match op with
		Plus -> "Plus"
		| Minus -> "Minus"
		| Times -> "Times"
		| Div -> "Div"
	and
	string_of_exp e = match e with
		Var id -> "Var \""^id^"\""
		| Const i -> "Const "^(string_of_int i)
		| Binop (e1, op, e2) -> "Binop("^string_of_exp e1^","^string_of_binop op^","^string_of_exp e2^")"
		| If (e1, e2, e3) -> "If("^string_of_exp e1^","^string_of_exp e2^","^string_of_exp e3^")"
	and
	string_of_stm s = match s with
		Assign (id, exp) -> "Assign(\""^id^"\","^string_of_exp exp^")"
		| Print l -> "Print "^string_of_list string_of_exp ";" l
		| Seq l -> "Seq "^string_of_list string_of_stm ";" l
	in
	print_endline (string_of_stm s)
